#include <unistd.h>
#include <cstdlib>
#include <cstring>
#include <cerrno>
#include <sys/types.h>
#include <sys/wait.h>
#include <iostream>
using namespace std;

int main(int argc, char* argv[]){
  int i=0;
  int nb_dec;
  int temps;
  pid_t pidf = 0;
  int status;

  if (argc != 3) {
    cerr << "Usage " << argv[0] << " <nb decendant> <temps du sleep>" << endl;
    exit(1);
  }

  nb_dec = atoi(argv[1]);
  temps = atoi(argv[2]);

  i = 0;
  while ((i < nb_dec)&&(pidf == 0)) {
    // attention il est TRES dangeureux de mettre un fork dans une boucle.
    cout <<  "dec n°" << i << " : je vais faire un fils" << endl;
    pidf = fork();
    if (pidf < 0) {
      cerr << "Problème avec le %d ieme fork : " << strerror(errno) << endl;
      exit(2);
    }
    if (pidf != 0) {
      // code du pere
      cout <<  "dec n°" << i << " : je viens de faire un fils" << endl;
      break; // on sort de la boucle pour ne pas créer n! fils
    } else {
      // code du fils
      i ++; // pour éviter la boucle infinie
      cout <<  "dec n°" << i << " : je viens naitre" << endl;
    }
  }
  sleep(temps);
  
  if (pidf != 0) {
    waitpid(pidf, &status, 0);
    if (WIFEXITED(status)) {
      cout <<  "dec n°" << i << " : mon fils s'est terminé en renvoyant " <<  WEXITSTATUS(status) << endl;
    }
    else if (WIFSIGNALED(status)) {
      cout <<  "dec n°" << i << " : mon fils s'est terminé sur le signal " << WTERMSIG(status) << endl;
    } else {
      cout <<  "dec n°" << i << " : mon fils a été stoppé" << endl;
    }
  }
  return 0;
}
